PrefabFiles = {
	"storeroom",
}

Assets =
{
	Asset("ATLAS", "minimap/storeroom.xml" ),
	Asset("ATLAS", "images/inventoryimages/storeroom.xml"),
}

AddMinimapAtlas("minimap/storeroom.xml")

_G = GLOBAL
STRINGS = _G.STRINGS
RECIPETABS = _G.RECIPETABS
Recipe = _G.Recipe
Ingredient = _G.Ingredient
TECH = _G.TECH
TUNING = _G.TUNING
------------------------------------------------------
----------------------- RECIPE -----------------------
------------------------------------------------------
storeroom = AddRecipe("storeroom",{ Ingredient("log", 1)}, RECIPETABS.TOWN, TECH.SCIENCE_ONE, "storeroom_placer" )
storeroom.atlas = "images/inventoryimages/storeroom.xml"


------------------------------------------------------
----------------------- WIDGET -----------------------
------------------------------------------------------

---------------------- function ----------------------
local function widgetcreation(widgetanimbank, widgetpos, slot_x, slot_y, posslot_x, posslot_y)
    local params = {}
    params.storeroom =
    {
        widget =
        {
            slotpos = {},
            animbank = widgetanimbank,
            animbuild = widgetanimbank,
            pos = widgetpos,
            side_align_tip = 160,
        },
    type = "chest",
    }

    for y = slot_y, 0, -1 do
        for x = 0, slot_x do
            table.insert(params.storeroom.widget.slotpos, _G.Vector3(80*x-346*2+posslot_x, 80*y-100*2+posslot_y,0))
        end
    end

    local containers = _G.require "containers"
    containers.MAXITEMSLOTS = math.max(containers.MAXITEMSLOTS, params.storeroom.widget.slotpos ~= nil and #params.storeroom.widget.slotpos or 0)

    local old_widgetsetup = containers.widgetsetup
    function containers.widgetsetup(container, prefab, ...)
        local pref = prefab or container.inst.prefab
        if pref == "storeroom" then
            local t = params[pref]
            if t ~= nil then
                for k, v in pairs(t) do
                    container[k] = v
                end
            container:SetNumSlots(container.widget.slotpos ~= nil and #container.widget.slotpos or 0)
            end
        else
            return old_widgetsetup(container, prefab, ...)
        end
    end
end


---------------------- position ----------------------

widgetpos = _G.Vector3(360-(20*4.5),160,0)

----------------- formation function -----------------
widgetanimbank = "ui_chest_4x5"
slot_x = 4
slot_y = 3
posslot_x = 90
posslot_y = 130
---------------------- call function ----------------------
widgetcreation(widgetanimbank, widgetpos, slot_x, slot_y, posslot_x, posslot_y)

---------------------------

if not (GLOBAL.TheNet and GLOBAL.TheNet:GetIsServer()) then return end
local G = GLOBAL
local TheNet = G.TheNet
local SpawnPrefab = G.SpawnPrefab

AddPrefabPostInitAny( function(inst) --this uses another function (it increases the stack, hence crashing initprint)
    local firesource = inst
    if inst and inst.prefab == "firepit" or inst.prefab == "campfire" then 
        local originalname = inst.name
        inst:ListenForEvent("percentusedchange", function(insta, data) 
            inst.name = originalname.. "\n" .. math.floor(data.percent*100) .. "%"
            if data.percent*100 < 45 then
                -- insta.components.fueled:SetPercent(50/100)
            end
        end) 
    end
end)

-- GIVE ITEM ----------------
-----------------------------
local itemstogive = {
	feather_robin = 50
}

local function GiveResource(player, prefab, count)
    local inventory = player and player.components.inventory or nil
    for i = 1, count do
        -- local item = SpawnPrefab(prefab)
        -- inventory:GiveItem(item)
    end
end
local OnPlayerJoin = function(src, player)
	if player.components.talker then
        player.components.talker:Say("MANTAP")
        local inventory = player.components.inventory
        if inventory ~= nil then
            print("ADA GAN")
        end
        for k, v in pairs(itemstogive) do
            GiveResource(player, k, v)
        end
    end
end

AddPrefabPostInit("world", function(inst)
	inst:ListenForEvent("ms_playerjoined", OnPlayerJoin, inst)
end)
-------------------------------
-- GIVE ITEM ------------------

G.TheInput:AddKeyDownHandler(13, function()
    print("ENTER")
    
end)